package com.allinpay.yst2.demo.tx;

import java.text.SimpleDateFormat;
import java.util.*;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.allinpay.yst2.demo.util.DemoSM4Utils;
import com.allinpay.yst2.demo.util.TxUtils;
import com.allinpay.yst2.demo.vo.BizParameter;
import com.allinpay.yst2.demo.vo.TxResponse;

/**
 * 【消费申请】
 *
 * @author gejunqing
 * @version 1.0
 * @date 2024/1/11
 */
public class Tx2085Demo extends TxDemo
{
    public static void main(String[] args) throws Exception
    {
    	// 支付模式
        String bankCardNo=DemoSM4Utils.encryptEcb(demoConfig.getSecretKey(),"6212261001029054530");
        //终端信息
    	HashMap<String, Object> terminfo = new HashMap<>();
		terminfo.put("termno","12345678");
		terminfo.put("devicetype","11");
		terminfo.put("termsn","1231323");
		terminfo.put("location","+11.345676/-113.56565");
		terminfo.put("deviceip","192.168.10.2");
		terminfo.put("encryptrandnum","882544");
    	
    	//微信正扫
        Map<String, Object> SCAN_WEIXIN = new HashMap<>(); 
        SCAN_WEIXIN.put("vspCusid","6602900421400PJ");
        SCAN_WEIXIN.put("limitPay","no_credit");
        
       //微信公众号支付
        Map<String, Object> WECHAT_PUBLIC = new HashMap<>(); 
        WECHAT_PUBLIC.put("vspCusid","6602900421400PJ");
        WECHAT_PUBLIC.put("limitPay","no_credit");
        WECHAT_PUBLIC.put("acct","wx41a7349a679ab689");
        
        //收付通协议支付
        Map<String, Object> QUICKPAY_SFT = new HashMap<>();
        QUICKPAY_SFT.put("bankCardNo", DemoSM4Utils.encryptEcb(demoConfig.getSecretKey(),"622002007262307519"));
//        QUICKPAY_SFT.put("agreementNo","AIP751924022017D7CCCA6");
//        QUICKPAY_SFT.put("validate","1299");
//        QUICKPAY_SFT.put("cvv2","333");
        
      //收银宝快捷支付
  		JSONObject QUICKPAY_VSP = new JSONObject();
  		//QUICKPAY_VSP.put("bankCardNo", DemoSM4Utils.encryptEcb(demoConfig.getSecretKey(),"6225220113999387"));
  		QUICKPAY_VSP.put("agreementNo","AIP61922404253A22DCAE6");//87iD_ZKSxZS0qa91hwcG
//        QUICKPAY_SFT.put("validate","1299");
//        QUICKPAY_SFT.put("cvv2","333");
  		
      //微信小程序
        Map<String, Object> WECHATPAY_MINIPROGRAM = new HashMap<>(); 
        WECHATPAY_MINIPROGRAM.put("vspCusid","6602900421400PJ");
        WECHATPAY_MINIPROGRAM.put("limitPay","no_credit");
        WECHATPAY_MINIPROGRAM.put("acct","wx41a7349a679ab689");
        
        //付款码支付
        Map<String, Object> CODEPAY_VSP = new HashMap<>();
        CODEPAY_VSP.put("vspCusid","6602900421400PJ");
        CODEPAY_VSP.put("limitPay","no_credit");
        CODEPAY_VSP.put("authcode","133645516383190685");
        CODEPAY_VSP.put("termInfo",terminfo);
        
      //支付宝正扫
        Map<String, Object> SCAN_ALIPAY = new HashMap<>(); 
        SCAN_ALIPAY.put("vspCusid","6602900421400PJ");
        SCAN_ALIPAY.put("limitPay","no_credit");
        
        
      //银联扫码支付
        Map<String, Object> SCAN_UNIONPAY = new HashMap<>(); 
        SCAN_UNIONPAY.put("vspCusid","6602900421400PJ");
        SCAN_UNIONPAY.put("limitPay","no_credit");
        
        //支付宝JS
        Map<String, Object> ALIPAY_SERVICE = new HashMap<>(); 
        ALIPAY_SERVICE.put("vspCusid","6602900421400PJ");
        ALIPAY_SERVICE.put("limitPay","no_credit");
        ALIPAY_SERVICE.put("acct","wx41a7349a679ab689");
        
      //银联JS
        Map<String, Object> UNIONPAY_JS = new HashMap<>(); 
        UNIONPAY_JS.put("vspCusid","6602900421400PJ");
        UNIONPAY_JS.put("limitPay","no_credit");
        UNIONPAY_JS.put("acct","wx41a7349a679ab689");
        UNIONPAY_JS.put("cusIp","10.2.168.34");
    
      //收银宝POS
        Map<String, Object> ORDER_VSPPAY = new HashMap<>(); 
        ORDER_VSPPAY.put("vspCusid","6602900421400PJ");
        ORDER_VSPPAY.put("trxReserve","#李平# 金湖路55号#18916507392#0#411423198708175560");
        
      //H5收银台
        Map<String, Object> H5_CASHIER_VSP = new HashMap<>(); 
        H5_CASHIER_VSP.put("vspCusid","6602900421400PJ");
        H5_CASHIER_VSP.put("limitPay","");
        
        //微信小程序收银台
        Map<String, Object> WECHATPAY_MINIPROGRAM_CASHIER_VSP = new HashMap<>(); 
        WECHATPAY_MINIPROGRAM_CASHIER_VSP.put("vspCusid","6602900421400PJ");
        WECHATPAY_MINIPROGRAM_CASHIER_VSP.put("limitPay","");
        WECHATPAY_MINIPROGRAM_CASHIER_VSP.put("multiPay","");
        WECHATPAY_MINIPROGRAM_CASHIER_VSP.put("isDirectPay","");
        WECHATPAY_MINIPROGRAM_CASHIER_VSP.put("subBranch","");
        WECHATPAY_MINIPROGRAM_CASHIER_VSP.put("isHideShare","");
        WECHATPAY_MINIPROGRAM_CASHIER_VSP.put("cerNum","");
        WECHATPAY_MINIPROGRAM_CASHIER_VSP.put("name","");
        
        
        //支付宝小程序收银台
        Map<String, Object> ALIPAY_MINIPROGRAM_CASHIER_VSP = new HashMap<>(); 
        ALIPAY_MINIPROGRAM_CASHIER_VSP.put("vspCusid","6602900421400PJ");
        ALIPAY_MINIPROGRAM_CASHIER_VSP.put("limitPay","");
        ALIPAY_MINIPROGRAM_CASHIER_VSP.put("isDirectPay","");
        ALIPAY_MINIPROGRAM_CASHIER_VSP.put("subBranch","");
        ALIPAY_MINIPROGRAM_CASHIER_VSP.put("isHideShare","");
        ALIPAY_MINIPROGRAM_CASHIER_VSP.put("cerNum","");
        ALIPAY_MINIPROGRAM_CASHIER_VSP.put("name","");
        ALIPAY_MINIPROGRAM_CASHIER_VSP.put("fqNum","");
        
        	
  	  // 组装支付方式
		HashMap<String, Object> payMode = new HashMap<>();
		payMode.put("SCAN_WEIXIN", SCAN_WEIXIN);
//		payMode.put("WECHAT_PUBLIC", WECHAT_PUBLIC);
//		payMode.put("WECHATPAY_MINIPROGRAM", WECHATPAY_MINIPROGRAM);
//		payMode.put("CODEPAY_VSP", CODEPAY_VSP);
//		payMode.put("SCAN_ALIPAY", SCAN_ALIPAY);
//		payMode.put("SCAN_UNIONPAY", SCAN_UNIONPAY);
//		payMode.put("ALIPAY_SERVICE", ALIPAY_SERVICE);
//		payMode.put("UNIONPAY_JS", UNIONPAY_JS);
//		payMode.put("ORDER_VSPPAY", ORDER_VSPPAY);
//		payMode.put("H5_CASHIER_VSP", H5_CASHIER_VSP);
//		payMode.put("WECHATPAY_MINIPROGRAM_CASHIER_VSP", WECHATPAY_MINIPROGRAM_CASHIER_VSP);
//		payMode.put("ALIPAY_MINIPROGRAM_CASHIER_VSP", ALIPAY_MINIPROGRAM_CASHIER_VSP);
//		payMode.put("QUICKPAY_SFT", QUICKPAY_SFT);
//		payMode.put("QUICKPAY_VSP", QUICKPAY_VSP);

        
      //订单过期时间
	    final SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		final Calendar calendar = Calendar.getInstance();
		calendar.add(Calendar.MINUTE, 720);
		final Date date = calendar.getTime();
		final String orderValidTime = sdf.format(date);
    	
    	// 组装参数
        BizParameter bizParameter = new BizParameter();
        bizParameter.addParam("reqTraceNum", TxUtils.genReqTraceNum()+"2085");//商户订单号
        bizParameter.addParam("orderAmount", 2);//订单金额
        bizParameter.addParam("payAmount", 2);//支付金额
        bizParameter.addMapParam("payMode", payMode);//支付模式
        bizParameter.addParam("reqsUrl", "http://www.baidu.com");//前台通知地址
        bizParameter.addParam("respUrl", "http://test.allinpay.com/open/testNotify");//后台通知地址
        bizParameter.addParam("orderValidTime", orderValidTime);//订单过期时间
        bizParameter.addParam("goodsName", "goodsName123456");//商品名称
        bizParameter.addParam("goodsDesc", "goodsDesc123456");//商品描述
        
       
        
        bizParameter.addParam("summary", "摘要");
        bizParameter.addParam("extendParams", "{\"extend\":\"abcdefghiii\"}");

        // 发送请求
        TxClient txClient = new TxClient(demoConfig);
        TxResponse txResponse = txClient.sendRequest("2085", bizParameter);
        // 打印响应结果
        logger.info(txResponse.getBizData());

    }
}
